//import terrapin.*;
import processing.pdf.*;

int XSIZE=int(3.6*297);
int YSIZE=int(3.6*210);

PFont font16, font32;
PGraphicsPDF pdf;

void setup() {
     noLoop();
     size(XSIZE,YSIZE);
     pdf = (PGraphicsPDF) beginRecord(PDF, "TTTT_Nr1_FLOAT_PEGASUS.pdf");
    //this was tricky, see JunTestFont or email 20-12-2011
}

class PPoint extends PVector {
      PPoint(float x, float y){
            super(x,y);
      }
      //the following method does not change "this" but makes a new point
      //I would have preferred a static method,  but that was not allowed
      //inpol interpolates "this" and B, to give a middle point, half way 
      PPoint intpol(PPoint B){
             PVector M = mult(PPoint.add(this,B),0.5);
             return new PPoint(M.x,M.y);
      }
      PPoint intpol(PPoint B, float f){
             PVector M = PPoint.add(mult(this,1-f),mult(B,f));
             return new PPoint(M.x,M.y);
      }
}

void setPosition(Terrapin t, PPoint P){
     t.x = (P.x);
     t.y = (P.y);
}
PPoint getPosition(Terrapin t){
     return new PPoint(t.x,t.y);
}
void setRotation(Terrapin t, float theta){
     t.setRotation(theta);
}
float getRotation(Terrapin t){
      return int(t.getRotation());
}
   
class TTTT {
      Terrapin t;
      //designed for vertical 
      //glide reflection axis only
      PPoint A,B,C,D,T1,T2;
      float a2b, a2d;
      TTTT(Terrapin trp){
         t=trp;
      }
void ABCD(PPoint inipos,int inidir) {
        // this method uses one arbitrary line AB and one arbitrary line AD;
        // the procedure encodes the logic of how the lines are positioned with 
        // respect to each other and the points A,B,C,D
        setPosition(t,inipos);
        setRotation(t,inidir);
        int s = 20; //scale, good values are 20, 24
        A = getPosition(t);
        //create AB arbitrarily
        A2B(t,s);
        a2b = getRotation(t);
        B = getPosition(t);
        setPosition(t,A);
        setRotation(t,inidir);
        //create AD arbitrarily
        A2D(t,s);
        D = getPosition(t);
        setRotation(t,inidir);
        //create DC as a copy of AB
        A2B(t,s);
        C = getPosition(t);
        setPosition(t,B);
        setRotation(t,inidir);
        //create BC as a copy of AD
        A2D(t,s);
        //give some auxilliary lines
        setPosition(t,A);
        A2Ddashed(t,s,D);
        setPosition(t,C);
        A2Ddashed(t,s,B);
        a2d = t.getRotation();
        T1 = A.intpol(D,.7);
        T2 = B.intpol(C,.7);
        setPosition(t,A.intpol(B).intpol(C.intpol(D)));
        setRotation(t,a2d);
        drwArrowFull(t,s);
        //done
        drwA(A,s);
        drwB(B,s);
        drwC(C,s);
        drwD(D,s);
        drwT(T1,s);
        drwT(T2,s);
      }//end ABCD
 void ABCDsmallversion(PPoint inipos,int inidir) {
        //always run ABCD (the big version first
        //it fills in the a2d direction etc.
        setPosition(t,inipos);
        setRotation(t,inidir);
        int s = 8; //scale, good values are 4,5,8,20, 24
        A = getPosition(t);
        A2B(t,s);
        B = getPosition(t);
        setPosition(t,A);
        setRotation(t,inidir);
        A2D(t,s);
        D = getPosition(t);
        setRotation(t,inidir);
        A2B(t,s);
        C = getPosition(t);
        setPosition(t,B);
        setRotation(t,inidir);
        A2D(t,s);
        //give one auxilliary line
        setPosition(t,A.intpol(B).intpol(C.intpol(D)));
        setRotation(t,a2d);
        //drwArrowFull(t,s);
        //done
        //drwA(A,s);
        //drwB(B,s);
        //drwC(C,s);
        //drwD(D,s);
      }//end ABCDsmallversion

}// end TTTT

void draw() {
     fill(0);
     stroke(0);
     background(255);
     pdf.textMode(SHAPE);
     Terrapin t = new Terrapin(this);
     font16 = createFont("Comic Sans MS",16); 
     font32 = createFont("Comic Sans MS",16); 
     drwIntro();
     TTTT tttt = new TTTT(t);
     
     //create one big basic figure
     tttt.ABCD(new PPoint(250,600),0);
     
     //create one smaller version
     PPoint origin = new PPoint(670,660);
     tttt.ABCDsmallversion(origin,0);
     
     //from this one derive the translation vectors
     //for the entire two-block and repeat by translations;
     //sorry for the double lines;
     PVector T1 = PVector.sub(tttt.B,tttt.A);
     PVector T2 = PVector.sub(tttt.D,tttt.A);
     for (int i=0;i<3;i++){//was 2
         for (int j=0;j<3;j++){ //was 3
             PPoint T = new PPoint(origin.x,origin.y);
             T.add(PVector.mult(T1,i));
             T.add(PVector.mult(T2,j));
             tttt.ABCDsmallversion(T,0);
         }
     }
     endRecord();
}

void drwArrowFull(Terrapin t, int scalefactor){
     //draw a big full arrow
     //s must be prferably arround 20
     t.setPenColor(255 , 0, 0);
     int s=scalefactor;
     strokeWeight(s/4+1);
     //outer arrow
     t.forward(3*s);
     t.left(90);
     t.forward(s/4);
     t.right(110);
     t.forward(s);
     t.right(160);
     t.forward(s);//fill tip
     t.forward(-s);//idem
     t.left(20);
     t.forward(s);
     t.right(110);
     t.forward(s/4);
     t.left(90);
     t.forward(3*s);
     t.right(90);
     t.forward(s/8);
}
void drwArrowOpen(Terrapin t, int scalefactor){
     //draw a big non-filled arrow
     //s must be prferably arround 20
     t.setPenColor(255 , 0, 0);
     int s=scalefactor;
     strokeWeight(s/8);
     t.forward(3*s);
     t.left(90);
     t.forward(s/4);
     t.right(110);
     t.forward(s);
     t.right(160);
     t.left(20);
     t.forward(s);
     t.right(110);
     t.forward(s/4);
     t.left(90);
     t.forward(3*s);
     t.right(90);
     t.forward(s/8);
}


void A2B(Terrapin t, int scalefactor){
     //made by my own program escherMaker, 
     //using something similar to Escher's pegaus 105 as input
     t.setPenColor(0, 0, 0);
     float s=float(scalefactor)/25;
     strokeWeight(scalefactor/8+2);
     //strokeWeight(1);
     t.left(52.1);
     t.forward(s*34.0);
     t.left(84.2);
     t.forward(s*30.0);
     t.left(-52.3);
     t.forward(s*38.0);
     t.left(-83.9);
     t.forward(s*36.0);
     t.left(22.4);
     t.forward(s*68.0);
     t.left(42.7);
     t.forward(s*14.0);
     t.left(-115.6);
     t.forward(s*29.0);
     t.left(49.7);
     t.forward(s*81.0);
     t.left(-91.1);
     t.forward(s*31.0);
     t.left(40.0);
     t.forward(s*17.0);
     t.left(6.8);
     t.forward(s*24.0);
     t.left(-54.4);
     t.forward(s*18.0);
     t.left(-31.8);
     t.forward(s*54.0);
     t.left(-4.5);
     t.forward(s*50.0);
     t.left(14.3);
     t.forward(s*21.0);
     t.left(31.4);
     t.forward(s*15.0);
     t.left(5.1);
     t.forward(s*11.0);
     t.left(70.7);
     t.forward(s*65.0);
     t.left(99.7);
     t.forward(s*27.0);
     t.left(35.2);
     t.forward(s*17.0);
     t.left(-90.4);
     t.forward(s*155.0);
 }





void A2D(Terrapin t, int scalefactor){
      //made by my own program escherMaker, 
     //using something similar to Escher's pegaus 105 as input
     float s=float(scalefactor)/25;
     strokeWeight(scalefactor/8+2);
     //strokeWeight(1);
     t.left(100.3);
     t.setPenColor(0, 0, 0);
     t.forward(s*11.0);
     t.left(37.8);
     t.forward(s*50.0);
     t.left(-44.8);
     t.forward(s*17.0);
     t.left(-53.1);
     t.forward(s*17.0);
     t.left(35.0);
     t.forward(s*43.0);
     t.left(-56.3);
     t.forward(s*33.0);
     t.left(1.3);
     t.forward(s*28.0);
     t.left(29.8);
     t.forward(s*15.0);
     t.left(35.0);
     t.forward(s*24.0);
     t.left(52.4);
     t.forward(s*14.0);
     t.left(19.0);
     t.forward(s*15.0);
     t.left(-2.2);
     t.forward(s*23.0);
     t.left(11.4);
     t.forward(s*4.0);
     t.left(16.4);
     t.forward(s*24.0);
     t.left(87.6);
     t.forward(s*11.0);
     t.left(82.5);
     t.forward(s*23.0);
     t.left(-61.1);
     t.forward(s*24.0);
     t.left(-59.2);
     t.forward(s*11.0);
     t.left(1.8);
     t.forward(s*13.0);
     t.left(-24.2);
     t.forward(s*8.0);
     t.left(-73.0);
     t.forward(s*23.0);
     t.left(0.2);
     t.forward(s*41.0);
     t.left(-71.9);
     t.forward(s*49.0);
     t.left(-61.1);
     t.forward(s*59.0);
     t.left(78.5);
     t.forward(s*15.0);
     t.left(-21.9);
     t.forward(s*34.0);
     t.left(-8.9);
     t.forward(s*86.0);
     t.left(42.8);
     t.forward(s*13.0);
     t.left(84.0);
     t.forward(s*38.0);
     t.left(15.0);
     t.forward(s*55.0);
}

void roundCornerRight180(Terrapin t, int d){
     //auxilliary for A2D
     t.right(30);
     for (int i=0; i<5; i++){
         t.forward(d/4);
         t.right(30);
     }
}
void roundCornerLeft180(Terrapin t, int d){
     t.left(30);
     for (int i=0; i<5; i++){
         t.forward(d/4);
         t.left(30);
     }
}
void roundCornerLeft90(Terrapin t, int d){
     t.left(30);
     for (int i=0; i<2; i++){
         t.forward(d/4);
         t.left(30);
     }
}

void A2Ddashed(Terrapin t, int scalefactor, PVector D){
     // this will be a coloured dashed line, straight, only for explanation
     // typically started in A, it will shoot towards position D
     t.setPenColor(0, 0, 255);
     int d=scalefactor;
     strokeWeight(d/8+1);
     PPoint  HERE = getPosition(t);
     PVector TODO = PPoint.sub(D,HERE);
     PVector STEP = PVector.mult(TODO,0.025);
     PPoint  NEXT = HERE;
     //warning: bug in moveToward(toX,toY,amount), 
     //in fact it does not use the amount at all
     for (int i=0;i<20;i++){
         t.drawing=true;
         t.moveToward(int(NEXT.x),int(NEXT.y),1.0);
         NEXT = new PPoint(NEXT.x+STEP.x,NEXT.y+STEP.y);
         t.drawing=false;
         t.moveToward(int(NEXT.x),int(NEXT.y),1.0);
         NEXT = new PPoint(NEXT.x+STEP.x,NEXT.y+STEP.y);
     }
     t.drawing=true; 
}

void drwIntro(){
     textFont(font32,32);
     text("Nr.1, Basic Type TTTT",200,50);
     textFont(font16,16);
     text("Shift the arbitrary line AB to DC, such that ABCD are the corners of a parallelogram (translation vector AD). Draw another arbitrary line from A to D and shift it into the position BC (translation vector AB)."
         , 200, 100,700,200); 
     text("Network 4444,"
         , 650, 200,700,100); 
     text("1 positioning."
         , 650, 220,700,100); 
}

void drwA(PVector p, int scalefactor){
     //to mark the points and write their name;
     //(name writing only only for the big versions);
     int d=scalefactor/2;
     strokeWeight(d/4+2);
     stroke(255,0,0);
     fill(255,0,0);
     ellipse(p.x,p.y,d+2,d+2); 
     if (d>5) { textFont(font32,32); text("A",p.x-10,p.y+35);}
}

void drwB(PVector p, int scalefactor){
     int d=scalefactor/2;
     strokeWeight(d/4+2);
     stroke(255,0,0);
     fill(255,0,0);
     ellipse(p.x,p.y,d+2,d+2); 
     if (d>5) { textFont(font32,32);text("B",p.x-20,p.y+35); }
}

void drwC(PVector p, int scalefactor){
     int d=scalefactor/2;
     strokeWeight(d/4+2);
     stroke(255,0,0);
     fill(255,0,0);
     ellipse(p.x,p.y,d+2,d+2); 
     if (d>5) { textFont(font32,32); text("C",p.x-10,p.y-10);}
}

void drwD(PVector p, int scalefactor){
     int d=scalefactor/2;
     strokeWeight(d/4+2);
     stroke(255,0,0);
     fill(255,0,0);
     ellipse(p.x,p.y,d+2,d+2); 
     if (d>5) { textFont(font32,32); text("D",p.x-10,p.y-12);}
}
void drwT(PVector p, int scalefactor){
     int d=scalefactor/2;
     strokeWeight(d/4+2);
     stroke(0,0,255);
     fill(0,0,255);
     if (d>5) { textFont(font32,32); text("T",p.x+5,p.y-12);}
}

void stop(){
     endRecord();
}

